import com.cyberbotics.webots.Controller;
import javax.swing.*;
import java.awt.*;
import java.awt.image.*;

import java.io.*;


public abstract class ALife0 extends Controller //MyController
{
  static int leftSensor, rightSensor;

  static int camera;

  public static void reset()
  {
    camera=robot_get_device("camera");
//    System.out.println("md - reset:");

    leftSensor=robot_get_device("ds1");
    rightSensor=robot_get_device("ds4");
//    System.out.println("ir reset: "+rightSensor+" "+leftSensor);

  }



  public static void main(String[] args)
  {
    main();
  }



  public static void main()
  {
    SensorsStatus sensorsStatus = new SensorsStatus();
    Speed speed = new Speed(0, 0);

    double energyPrintLimit = 91.0;
    int globalTime = 0;

    int[] image;
    int width,height;
    int leftIR, rightIR;

    camera_enable(camera,64);
    distance_sensor_enable(leftSensor,64);
    distance_sensor_enable(rightSensor,64);
    robot_battery_sensor_enable(64);

    sensorsStatus.setImageParams(camera_get_width(camera), camera_get_height(camera) );

    int numSkills = 4;
    int currentSkillIndex = 1;
    Skill [] skill = new Skill[numSkills];

    skill[0] = new RndWalk(); // exception handler
    skill[1] = new LocateFeeder();
    skill[2] = new TrackFeeder();
    skill[3] = new TouchFeeder();

    skill[currentSkillIndex].init();
    for(;;)
    {
      sensorsStatus.setImage(camera_get_image(camera));
      sensorsStatus.setIR( distance_sensor_get_value(leftSensor), distance_sensor_get_value(rightSensor) );
      sensorsStatus.setEnergy(robot_battery_sensor_get_value());

      try
      {
        speed = skill[currentSkillIndex].run(sensorsStatus);
        if(skill[currentSkillIndex].term())
        {
          currentSkillIndex = (currentSkillIndex + 1) % numSkills;
          skill[currentSkillIndex].init();

//          System.out.println("skill "+ currentSkillIndex);
        }
      }
      catch (Exception e)
      {
//        System.out.println("exception thrown for skill "+ currentSkillIndex);
        speed.set(0, 0);
        currentSkillIndex = 0;
        skill[currentSkillIndex].init();
      }

      differential_wheels_set_speed(speed.leftSpeed(), speed.rightSpeed());

      if(sensorsStatus.energy() > energyPrintLimit + 10)
      {
//        System.out.println("Charged energy to [" + globalTime + "]= " + sensorsStatus.energy());
        energyPrintLimit += 5;
      }

      if(sensorsStatus.energy() < energyPrintLimit)
      {
//        System.out.println("Robot's energy [" + globalTime + "]= " + sensorsStatus.energy());
        energyPrintLimit -= 10;
      }

      globalTime++;
      robot_step(64);
    }
  }
}
