/** Feeder - class storring info about detected feeder */

public class Feeder
{
  public Feeder()
  {
    m_position = -1;
    m_size = 0;
  }

  public Feeder(Image i_image)
  {
    set(i_image.data(), i_image.width(), i_image.height());
  }

  public Feeder(int i_position, int i_size)
  {
    m_position = i_position;
    m_size = i_size;
  }

  public int position()
  {
    return m_position;
  }

  public int size()
  {
    return m_size;
  }

  public void set(int []image, int width, int height)
  {
    int i, red, green, blue;

    int lineStart = width * (height - 2) / 2;

    int startPos = -1;

    for( i = lineStart; i < lineStart + width; i++)
    {
      red   = (image[i] & 0x00ff0000)>>16;
      green = (image[i] & 0x0000ff00)>>8;
      blue  = (image[i] & 0x000000ff);

      int value = green - ((red > blue) ? red : blue);

      image[i] = 0;

      // return first detection of green color
      if((value > 200) && (startPos < 0))
      {
        startPos = i;
      }

      if((startPos >= 0) && ((value <= 199) || (i == lineStart + width -1)))
      {
//        System.out.println("Feeder detected (size " + (i - startPos) + ")");
        m_position = i - lineStart;
        m_size = i - startPos;
        return;
      }
    }
    m_position = -1; // not defined
  }



  int m_position;
  int m_size;
}